#!/bin/bash
#############################################################################################
# Updates DDNS (www.ddnss.de)																#
# Support@swt-online.de																		#
# Modified from Fabian Pfaff (fabian.pfaff@aol.de)
# Version 1.2																				#
#############################################################################################

USERNAME="yourusername"
PASSWORD="yourpassword"
HOSTNAME="hostname.ddnss.de"

EMAIL=1
EMAILADDRESS="yourmail@domain.de"
EMAILSUBJECT="DDNS Update"

PATHNAME="/opt/ddnss"
VERSION="1.2"

#############################################################################################
# Put this line in your crontab																#
# */5 * * * * root /opt/ddnss/ddupdate.sh > /dev/null 2>&1																				#
#############################################################################################

#############################################################################################
#     HTML Email                                                                            #
#############################################################################################
function SendHTMLEmailGood() {

echo "From: admin
To: $EMAILADDRESS
MIME-Version: 1.0
Subject: $EMAILSUBJECT
Content-Type: text/html
<html>
	<head>
		<title>
			SWT DDNS Report
		</title>
	</head>
	<body style='font-family:Trebuchet MS; font-size: 10pt; color:#444444;'>
		<span style='font-size:10pt; font weight:normal; font-style:italic; '>SWT DDNS Report</span>
		<br>
		<br>
		<span style='font-size:16pt; font weight:normal; font-style:normal; '>SWT Business Server</span>
		<br>
		<span style='font-size:11pt; font weight:normal; font-style:normal; color: green;'>DDNS Update erfolgreich abgeschlossen</span>
		<br>
		<br>
		<table cellspacing='0' style='font-family: Lucida Sans Unicode, Lucida Grande, Sans-Serif; font-size: 12px; margin: 0px; width: 650px; text-align: left; border-collapse: collapse; border-top: 7px solid #E7EAEE; border-bottom: 7px solid #E7EAEE;'>
			<tr style='background: #F8F8FF;'>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				DDNS Update gestartet:
				</td>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				$MESSAGESTARTTIME
				</td>
			</tr>
			<tr style='background: #F8F8FF;'>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				DDNS Update abgeschlossen:
				</td>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				$SCRIPTFINISHTIME
				</td>
			</tr>
			<tr style='background: #F8F8FF;'>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				Script Version:
				</td>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				$VERSION
				</td>
			</tr>
			<tr style='background: #F8F8FF;'>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				Servername:
				</td>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				$(hostname).$(dnsdomainname)
				</td>
			</tr>
			<tr style='background: #F8F8FF;'>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				WAN IP Adresse:
				</td>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				$NEW_IP
				</td>
			</tr>
		</table>
		<br><br>
		<br><span style='color:navy; font-weight:bold;'>DDNS Update gestartet: $MESSAGESTARTTIME</span><br>
		<br>
		<br><span style='color:#444444; font-weight:normal;'>DDNS Update Informationen:</span><br>
		<br><span style='color:green; font-weight:normal;'>Meldung von DDNSS: $MESSAGE</span>
		<br>
		<br>
		<br><span style='color:navy; font-weight:bold;'>DDNS Update abgeschlossen: $SCRIPTFINISHTIME</span><br>
		<br>
		<br>
		<div style='color:#666666'>
		_____________________________________________________________________________
		<br>
		<span style='font-size:8pt; font weight:normal; font-style:italic; '>Report erstellt von SWT DDNS Update Support@swt-online.de</span>
		<br>
		<span style='font-size:8pt; font weight:normal; font-style:italic; '>http://www.swt-online.de</span>
		</div>
		</div>
	</body>
</html>" \
| /usr/sbin/sendmail -t
}

#############################################################################################
#     HTML Email                                                                            #
#############################################################################################
function SendHTMLEmailError() {

echo "From: admin
To: $EMAILADDRESS
MIME-Version: 1.0
Subject: $EMAILSUBJECT "Error"
Content-Type: text/html
<html>
	<head>
		<title>
			SWT DDNS Report
		</title>
	</head>
	<body style='font-family:Trebuchet MS; font-size: 10pt; color:#444444;'>
		<span style='font-size:10pt; font weight:normal; font-style:italic; '>SWT DDNS Report</span>
		<br>
		<br>
		<span style='font-size:16pt; font weight:normal; font-style:normal; '>SWT Business Server</span>
		<br>
		<span style='font-size:11pt; font weight:normal; font-style:normal; color: red;'>DDNS Update mit Fehlern abgbrochen</span>
		<br>
		<br>
		<table cellspacing='0' style='font-family: Lucida Sans Unicode, Lucida Grande, Sans-Serif; font-size: 12px; margin: 0px; width: 650px; text-align: left; border-collapse: collapse; border-top: 7px solid #E7EAEE; border-bottom: 7px solid #E7EAEE;'>
			<tr style='background: #F8F8FF;'>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				DDNS Update gestartet:
				</td>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				$MESSAGESTARTTIME
				</td>
			</tr>
			<tr style='background: #F8F8FF;'>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				DDNS Update abgeschlossen:
				</td>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				$SCRIPTFINISHTIME
				</td>
			</tr>
			<tr style='background: #F8F8FF;'>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				Script Version:
				</td>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				$VERSION
				</td>
			</tr>
			<tr style='background: #F8F8FF;'>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				Servername:
				</td>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				$(hostname).$(dnsdomainname)
				</td>
			</tr>
			<tr style='background: #F8F8FF;'>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				WAN IP Adresse:
				</td>
				<td style='padding: 5px; background: #F8F8FF; border-right: 1px solid #E7EAEE; border-left: 1px solid #E7EAEE; color: #669;'>
				$NEW_IP
				</td>
			</tr>
		</table>
		<br><br>
		<br><span style='color:navy; font-weight:bold;'>DDNS Update gestartet: $MESSAGESTARTTIME</span><br>
		<br>
		<br><span style='color:#444444; font-weight:normal;'>DDNS Update Informationen:</span><br>
		<br><span style='color:red; font-weight:normal;'>Meldung von DDNSS: $MESSAGE</span>		
		<br>
		<br>
		<br><span style='color:navy; font-weight:bold;'>DDNS Update abgeschlossen: $SCRIPTFINISHTIME</span><br>
		<br>
		<br>
		<div style='color:#666666'>
		_____________________________________________________________________________
		<br>
		<span style='font-size:8pt; font weight:normal; font-style:italic; '>Report erstellt von SWT DDNS Update Support@swt-online.de</span>
		<br>
		<span style='font-size:8pt; font weight:normal; font-style:italic; '>http://www.swt-online.de</span>
		</div>
		</div>
	</body>
</html>" \
| /usr/sbin/sendmail -t
}


#############################################################################################
# getExternalIp																				#
#############################################################################################
getExternalIp(){
	EXTERNAL_IP=`wget -q -O - http://ip4.ddnss.de/meineip.php| grep -o '[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}'`
	if [ -z $EXTERNAL_IP ] ; then
		logEvent "Externe IP Adresse kann derzeit nicht ermittelt werden, es wird kein DDNS Update durchgeführt."
	fi	
}

#############################################################################################
# getExternalIp6																			#
#############################################################################################
getExternalIp6(){
	EXTERNAL_IP6=`wget -q -O - http://ip6.ddnss.de/meineip.php| grep -o -E '(([0-9a-fA-F]{1,4}:){7,7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:)|fe80:(:[0-9a-fA-F]{0,4}){0,4}%[0-9a-zA-Z]{1,}|::(ffff(:0{1,4}){0,1}:){0,1}((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])\.){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])|([0-9a-fA-F]{1,4}:){1,4}:((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])\.){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9]))'`
	if [ -z $EXTERNAL_IP6 ] ; then
		logEvent "Externe IPv6 Adresse kann derzeit nicht ermittelt werden, es wird kein DDNS Update durchgeführt."
	fi	
}

#############################################################################################
# getDdnsIp																					#
#############################################################################################
getDdnsIp(){
	DDNS_IP=`cat $PATHNAME/updip.txt`
}

#############################################################################################
# getDdnsIp6																				#
#############################################################################################
getDdnsIp6(){
	DDNS_IP6=`cat $PATHNAME/updip6.txt`
}

#############################################################################################
# logEvent																					#
#############################################################################################
logEvent(){
	/bin/logger -t ddnss "$*"
}


#############################################################################################
# doOnUpdate																				#
#############################################################################################
doOnUpdate() {

		#update DDNS-Address
		SECRET_URL="https://www.ddnss.de/nic/update?hostname=$HOSTNAME&myip=$NEW_IP&myip6=$NEW_IP6" 
		logEvent $SECRET_URL 
		DDNS_RESULT="$(wget --no-check-certificate --http-user=$USERNAME --http-password=$PASSWORD -q -O - $SECRET_URL)"
		logEvent "Update Result DDNS: $DDNS_RESULT"

		#endtime
		SCRIPTFINISHTIME=$(date "+%d.%m.%Y %T")	
			
		#DDNS Result
		case "$DDNS_RESULT" in
			good*)
				MESSAGE="Your hostname has been updated."
				logEvent $MESSAGE
				echo $NEW_IP > $PATHNAME/updip.txt
				echo $NEW_IP6 > $PATHNAME/updip6.txt
				#Send mail
				if [ $EMAIL -eq 1 ] ; then
						SendHTMLEmailGood $MESSAGE				
				fi			
                ;;
			nochg*)
				MESSAGE="This update was identical to your last update, so no changes were made to your hostname configuration."
				logEvent $MESSAGE
		        echo $NEW_IP > $PATHNAME/updip.txt
				echo $NEW_IP6 > $PATHNAME/updip6.txt
				#Send mail
				if [ $EMAIL -eq 1 ] ; then
						SendHTMLEmailGood $MESSAGE				
				fi			
                ;;
			notfqdn*)
				MESSAGE="The hostname you specified $DDNS_URL was not valid." 
				logEvent $MESSAGE
				#Send mail
				if [ $EMAIL -eq 1 ] ; then
						SendHTMLEmailError $MESSAGE				
				fi			
				;;
			nohost*)
				MESSAGE="The specified hostname $DDNS_URL does not exist."
				logEvent $MESSAGE
				#Send mail
				if [ $EMAIL -eq 1 ] ; then
						SendHTMLEmailError $MESSAGE				
				fi			
				;;
			!yours*)
				MESSAGE="The specified hostname $DDNS_URL does not belong to you."
				logEvent $MESSAGE
				#Send mail
				if [ $EMAIL -eq 1 ] ; then
						SendHTMLEmailError $MESSAGE				
				fi		
				;;
			badauth*)
				MESSAGE="Invalid username or password. Authentication failed."
				logEvent $MESSAGE
				#Send mail
				if [ $EMAIL -eq 1 ] ; then
						SendHTMLEmailError $MESSAGE				
				fi			
				;;
			badagent*)
				MESSAGE="Your user agent is not valid."
				logEvent $MESSAGE
				#Send mail
				if [ $EMAIL -eq 1 ] ; then
						SendHTMLEmailError $MESSAGE				
				fi			
				;;
			badsys*)
				MESSAGE="The system parameter is invalid."
				logEvent $MESSAGE
				#Send mail
				if [ $EMAIL -eq 1 ] ; then
						SendHTMLEmailError $MESSAGE				
				fi				
				;;
			dnserr*)
				MESSAGE="A DNS error has occurred on our end. We apologize for any inconvenience."
				logEvent $MESSAGE
				#Send mail
				if [ $EMAIL -eq 1 ] ; then
						SendHTMLEmailError $MESSAGE				
				fi			
				;;
			disabled*)
				MESSAGE="Account Disabled or Locked."
				logEvent $MESSAGE
				#Send mail
				if [ $EMAIL -eq 1 ] ; then
						SendHTMLEmailError $MESSAGE				
				fi		
				;;
			911*)
				MESSAGE="A critical error has occurred on our end. We apologize for any inconvenience."
				logEvent $MESSAGE
				#Send mail
				if [ $EMAIL -eq 1 ] ; then
						SendHTMLEmailError $MESSAGE				
				fi			
				;;
			*Maximum*update*)
				MESSAGE="The maximum update possibility is achieved."
				logEvent $MESSAGE
				echo $NEW_IP > $PATHNAME/updip.txt
				echo $NEW_IP6 > $PATHNAME/updip6.txt
				#Send mail
				if [ $EMAIL -eq 1 ] ; then
						SendHTMLEmailError $MESSAGE
				fi
				;;				
			*)
				MESSAGE="Unknown response"
				logEvent $MESSAGE
				#Send mail
				if [ $EMAIL -eq 1 ] ; then
						SendHTMLEmailError $MESSAGE				
				fi			
				;;
		esac
		
		return
}


#############################################################################################
# Main																						#
#############################################################################################
{	
	#starttime
	MESSAGESTARTTIME=$(date "+%d.%m.%Y %T")
	#get current ddns-ip
	getDdnsIp
	OLD_IP=$DDNS_IP

	getDdnsIp6
	OLD_IP6=$DDNS_IP6
	
	#get current external IP
	getExternalIp
	NEW_IP=$EXTERNAL_IP

	getExternalIp6
	NEW_IP6=$EXTERNAL_IP6
	
	if [ -n "$NEW_IP" ] ; then
		if [ "$OLD_IP" != "$NEW_IP" ] ; then
			doOnUpdate
		fi
	elif [ -n "$NEW_IP6" ] ; then
		if [ "$OLD_IP6" != "$NEW_IP6" ] ; then
			doOnUpdate
		fi
	fi
}